function [w err] = call_cplex(Hyp, truth_train, test, truth_test, Neigh_index, pVals)

%n weak classifiers
%m training examples
[m n] = size(Hyp);

A = construct_coeff(Hyp, truth_train, Neigh_index);
c = construct_obj(n, m, Neigh_index, pVals);
b = zeros(size(A,1),1);
b(1:m) = 1;

lb = zeros(m + n + size(Neigh_index,1),1);
ub = inf * ones(m + n + size(Neigh_index,1),1);

ge = 1:m;
le = (m + 1):size(A,1);

disp('Calling cplex...');
[obj, x, lambda, status] = lp_cplex(c, A, b, lb, ub, le, ge, 1000000);

w = x(1:n);

disp(sprintf('Number of non-zero weights: %d', size(find(w),1)));

%If CPLEX did not exit normally, block the weights that it returns, and
%continue.
if status ~= 1
    disp(sprintf('Problem: status was %d', status));
    w = zeros(n,1);
end

disp(sprintf('Trainset error: %f', sum(abs(sign(Hyp * w) - double(truth_train)))/(2*numel(truth_train))));

err = sign(test * w) - double(truth_test);