function [A] = construct_coeff(Hyp, truth_train, Neigh_index)

[M N] = size(Hyp);
P = size(Neigh_index,1);

rows = M + 2*P;
cols = N + M + P;
num_el = numel(Hyp) + M + 6 * P;
%disp(sprintf('Number of non-zero elements in coefficient array: %d', num_el));

%accuracy constraints
Hyp = Hyp .* repmat(double(truth_train), 1, N);
[Iacc Jacc Vacc] = find(Hyp);

%Slacks
Isl = zeros(M,1);
Jsl = zeros(M,1);
Vsl = zeros(M,1);
for i=1:M
    Isl(i) = i;
    Jsl(i) = i + N;
    Vsl(i) = 1;
end

%Neighbor constraints
Inbr = zeros(6*P,1);
Jnbr = zeros(6*P,1);
Vnbr = zeros(6*P,1);

offC = M + N;

rowCntr = M + 1;
elCntr = 1;
for i=1:P
    a = Neigh_index(i,1);
    b = Neigh_index(i,2);
    Inbr(elCntr) = rowCntr;
    Jnbr(elCntr) = a;
    Vnbr(elCntr) = 1;
    elCntr = elCntr + 1;
    
    Inbr(elCntr) = rowCntr;
    Jnbr(elCntr) = b;
    Vnbr(elCntr) = -1;
    elCntr = elCntr + 1;
    
    Inbr(elCntr) = rowCntr;
    Jnbr(elCntr) = offC + i;
    Vnbr(elCntr) = -1;
    elCntr = elCntr + 1;
    
    rowCntr = rowCntr + 1;

    Inbr(elCntr) = rowCntr;
    Jnbr(elCntr) = a;
    Vnbr(elCntr) = -1;
    elCntr = elCntr + 1;
    
    Inbr(elCntr) = rowCntr;
    Jnbr(elCntr) = b;
    Vnbr(elCntr) = 1;
    elCntr = elCntr + 1;
    
    Inbr(elCntr) = rowCntr;
    Jnbr(elCntr) = offC + i;
    Vnbr(elCntr) = -1;
    elCntr = elCntr + 1;
    
    rowCntr = rowCntr + 1;
end

I = [Iacc; Isl; Inbr];
J = [Jacc; Jsl; Jnbr];
V = [Vacc; Vsl; Vnbr];

A = sparse(double(I), double(J), double(V), double(rows), double(cols), double(num_el));


% %Blocked variable constraints
% for i=1:size(blocked,1)
%     if blocked(i) > 0
%         A(rowCntr,i) = 1;
%         rowCntr = rowCntr + 1;
%     end
% end