function [SOLUTION  CL_EVAL] = create_clustering(Data, truth, Test_Train)
%function [SOLUTION  CL_EVAL] = create_clustering(Data, truth, Test_Train)


%num of hypothesis
NP=size(Data,2);
%num of images
N=size(Data,1);

%the data structure containing the misclassification error (inaccuracy) values so 0.31 means went
%wrong 31%
%and the corresponding hypothesis number
%cl_eval(:,1) is the hypothesis number
%cl_eval(:,2) is the accuracy values
%SOLUTION(i,:) will have the class labels of the data items on
%hypothesis i
CL_EVAL=zeros(NP, 3);
SOLUTION = zeros(NP, N);


% if you do SOLUTION(1,:), it returns the class labels for the first
% hypothesis as determined by a max-margin clustering
% if you do CL_EVAL(1.:), it returns 1.0000    0.3103, meaning hypothesis 1
% and inaccuracy 31% (if we were to have access to ground truth), so we
% can use this value only for final evaluation etc.

%l is the hypothesis number (also the voxel number in the foreground)

%code to create clustering

pos = truth == 1 & Test_Train == 1;
neg = truth == -1 & Test_Train == 1;
% Npos = numel(pos);
% Nneg = numel(neg);

%load params window
load params B

for l=1:NP
    thresh = (mean(Data(pos,l)) + mean(Data(neg,l)))/2;

%     [jnk solution] = ttest2([Data(:,l)';nan(93, N)], repmat(Data(pos,l), 1, N), 10^-8, 'both', 'unequal');
%     solution = 2*solution' - 1;
    solution = 2./(1+exp(B*(thresh - Data(:,l)))) - 1;

%     [eval, match] = vec_compare_new(truth,solution);
%     diff = match-eye(2,2);
    
    eval = sum(abs(solution' - double(truth')))/(numel(truth)*2);

    CL_EVAL(l,1) = l;
    CL_EVAL(l,2) = eval;
    CL_EVAL(l,3) = thresh;

    SOLUTION(l,:) = solution;
end

%save cl_eval.mat CL_EVAL SOLUTION
